<?php

	class controller_component_guest extends component {

		public function action_index() {

		  	$this->data['URI'] = $_SERVER['REQUEST_URI'];

			$this->page['title'] = 'Гостевая книга ' . SITE_NAME;
			$this->page['keywords'] = 'Гостевая книга';
			$this->page['description'] = 'Гостевая книга';

			$guest_info = $this->model->get_component_info('guest');
			$this->data['page_name'] = $guest_info['name'];

			$this->model->createTable();	
			if (isset($_POST['deleteMessage'])) {
				$this->model->deleteNote($_POST['deleteMessage']);
			} 			
			if (!empty($_POST['answerArea']) && isset($_POST['sendAnswer'])) {
				$answer = '';
				foreach($_POST['answerArea'] as $textArea) {
					$answer .= $textArea;
				}

				$this->model->createAnswer($_POST['sendAnswer'], $answer);
			} 

			if (isset($_POST['submit'])) {
				
				$errors = array();	
				
				$message = htmlspecialchars($_POST['message']);
				$this->data['messageText'] = $message;

				$captcha = htmlspecialchars($_POST['captcha']);
				$post = htmlspecialchars($_POST['post']);
				$this->data['postText'] = $post;
				$phone = htmlspecialchars($_POST['phone']);
				$this->data['phoneText'] = $phone;

				if (empty($post)) {
					$this->data['postError'] = 'Введите почту.';
					array_push($errors, $this->data['postError']);
				} elseif (!preg_match("/([\w\-]+\@[\w\-]+\.[\w\-]+)/", $post)) {
					$this->data['postError'] = 'Введенная почта некорректна.';
					array_push($errors, $this->data['postError']);
				}

				$phoneCharArr = array('1', '2', '3', '4', '5' ,'6', '7', '8', '9', '0', '-', '+', ' ', '(', ')', '');
				$phoneMatch = preg_split('//', $phone);  
				$phonePushArr = array();
				foreach ($phoneMatch as $key => $value) {
					if (!in_array($value, $phoneCharArr)) {
						array_push($phonePushArr, $value);
					}
				}
				if (empty($phone)) {
					$this->data['phoneError'] = 'Введите телефон.';
					array_push($errors, $this->data['phoneError']);
				} elseif (!empty($phonePushArr)) {
					$this->data['phoneError'] = 'Введенный телефон некорректен.';
					array_push($errors, $this->data['phoneError']);
				}

				if (empty($message)) {
					$this->data['messageError'] = 'Введите отзыв.';
					array_push($errors, $this->data['messageError']);
				}

				if ($captcha != $_SESSION['captcha']) {
					$this->data['captchaError'] = 'Капча введена неверно.';
					array_push($errors, $this->data['captchaError']);
				}	

				if (!empty($errors)) {
					$div = '<div class="error">'; 
					foreach ($errors as $errText) {
						$div .= $errText . '<br>';
					}
					$div .= '</div>';
					$this->data['errorText'] = $div;
				}

				if (count($errors) == 0) {
							
					$curDate = date('Y-m-d H:i:s');

					$this->model->insertNote($phone, $post, $message, $curDate);

					$this->data['phoneText'] = '';
					$this->data['postText'] = '';
					$this->data['messageText'] = '';
					$this->data['success'] = '<div class="success">Спасибо за оставленный отзыв!</div>';

				}

			}

			$results = $this->model->readNotes();
			$showMessage = array(
				'id' => array(),
				'creationDate' => array(),
				'phone' => array(),
				'post' => array(),
				'message' => array()				
			);
			foreach ($results as $row) {
				array_push($showMessage['id'], $row['id']);	
				array_push($showMessage['creationDate'], $row['creationDate']);	
				array_push($showMessage['phone'], $row['phone']);	
				array_push($showMessage['post'], $row['post']);	
				array_push($showMessage['message'], $row['message']);	
			}
			$countArr = count($showMessage['id']); 
			$this->data['countArr'] = $countArr;
			$this->data['num'] = 0;
			$this->data['showMessage'] = $showMessage;

			$this->page['head'] = $this->add_css_file(SITE_URL . '/modules/components/guest/front_end/views/guest.css');
			$this->page['html'] = $this->load_view();
			return $this->page;
		}

	}
	
?>